void io_hlt(void);
void io_cli(void);
void io_out8(int port, int data);
int io_load_eflags(void);
void io_store_eflags(int eflags);

/*    Ͽ  ־ ϱ  Ѵٸ,
	     ȴ. */

void init_palette(void);
void set_palette(int start, int end, unsigned char *rgb);

void HariMain(void)
{
	int i; /*  .i ϴ  32Ʈ  */
	char *p; /* p ϴ  BYTE [...]  */

	init_palette(); /* ȷƮ  */

	p = (char *) 0xa0000; /*   */

	for (i = 0; i <= 0xffff; i++) {
		p[i] = i & 0x0f;
	}

	for (;;) {
		io_hlt();
	}
}

void init_palette(void)
{
	static unsigned char table_rgb[16 * 3] = {
		0x00, 0x00, 0x00,	/*  0: */
		0xff, 0x00, 0x00,	/*  1:  */
		0x00, 0xff, 0x00,	/*  2: ʷ */
		0xff, 0xff, 0x00,	/*  3: Ȳ */
		0x00, 0x00, 0xff,	/*  4: Ķ */
		0xff, 0x00, 0xff,	/*  5:  */
		0x00, 0xff, 0xff,	/*  6:  */
		0xff, 0xff, 0xff,	/*  7: */
		0xc6, 0xc6, 0xc6,	/*  8: ȸ */
		0x84, 0x00, 0x00,	/*  9:ο  */
		0x00, 0x84, 0x00,	/* 10:ο ʷ */
		0x84, 0x84, 0x00,	/* 11:ο Ȳ */
		0x00, 0x00, 0x84,	/* 12:ο Ķ */
		0x84, 0x00, 0x84,	/* 13:ο  */
		0x00, 0x84, 0x84,	/* 14:ο  */
		0x84, 0x84, 0x84	/* 15:ο ȸ */
	};
	set_palette(0, 15, table_rgb);
	return;

	/* static char   ۿ    DBɿ  */
}

void set_palette(int start, int end, unsigned char *rgb)
{
	int i, eflags;
	eflags = io_load_eflags();	/* ͷƮ 㰡 ÷  Ѵ */
	io_cli(); 			/* 㰡 ÷׸ 0 Ͽ ͷƮ  Ѵ */
	io_out8(0x03c8, start);
	for (i = start; i <= end; i++) {
		io_out8(0x03c9, rgb[0] / 4);
		io_out8(0x03c9, rgb[1] / 4);
		io_out8(0x03c9, rgb[2] / 4);
		rgb += 3;
	}
	io_store_eflags(eflags);	/* ͷƮ 㰡 ÷׸  ǵ */
	return;
}
